﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private streamer As AudioStreamer
	Dim buffers As List
	
	Private output As OutputStream
	Private mBitRate As Int = 16
	Private mSampleRate As Int = 44100
	Private mMono As Boolean = True
	Private LameEncoder As liblameEncoder
	
	Private Timer_Convert As Timer
	
End Sub

Sub Service_Create
	streamer.Initialize("streamer", mSampleRate, mMono, mBitRate, streamer.VOLUME_MUSIC)
	buffers.Initialize
End Sub


Sub Service_Start (StartingIntent As Intent)
	srv_location_firebase.Flag_Enconding = False

	Timer_Convert.Initialize ( "Timer_Convert", 1000)
	Timer_Convert.Enabled = False
End Sub

Sub Service_Destroy

End Sub

Sub streamer_RecordBuffer (Buffer() As Byte)
	
	If Main.recording Then output.WriteBytes(Buffer, 0, Buffer.Length)
	'the above check is required as the last message will arrive after we call StopRecording.

End Sub

Sub StartRecording
	Main.recording = True
	buffers.Clear
	output = StartWaveFile(Main.gDir_Arq_Som, Main.gArq_Som, mSampleRate, mMono, mBitRate)
'	output = StartWaveFile(File.DirRootExternal, Main.mFileName, mSampleRate, mMono, mBitRate)
	streamer.StartRecording
End Sub

Sub StopRecording
	Main.gArq_Som_Ult = Main.gArq_Som
	srv_location_firebase.Flag_Enconding = True
	Main.recording = False
	Try
		streamer.StopRecording
	Catch
		Log(LastException)
	End Try
	Try
		output.Close
	Catch
		Log(LastException)
	End Try
	Try
		CloseWaveFile(Main.gDir_Arq_Som, Main.gArq_Som)
	Catch
		Log(LastException)
	End Try
	
	Timer_Convert.Enabled = True	
	
End Sub


Sub Timer_Convert_Tick
	Dim xArq_Mp3, xArq_Wav, xDir  As String
	xArq_Wav = Main.gArq_Som_Ult
	xArq_Mp3 = xArq_Wav.Replace (".wav", ".mp3")
	xDir = Main.gDir_Arq_Som
	LameEncoder.Initialize("LameEncoder")
	If LameEncoder.SetFiles(File.Combine(xDir, xArq_Wav), File.Combine(xDir, xArq_Mp3)) Then
#if log
		Log ( "*** inicio encode " & xArq_Mp3 )
#End If
		'	LameEncoder.SetQuality(LameEncoder.LAME_PRESET_STANDARD)	'	adjust to suit
		Timer_Convert.Enabled = False  'para contador se não tenta novamente
		LameEncoder.Encode
	Else
#if log
		Log ( "*** inicio encode error " & xArq_Mp3 & " - " & xDir )
#End If
			
	End If
	
End Sub


Sub LameEncoder_EncodeComplete(Success As Boolean)
	If Success Then
		File.Delete ( Main.gDir_Arq_Som, Main.gArq_Som_Ult )
		Log("** liblame Encode SUCCEEDED " & Main.gArq_Som_Ult )
		srv_location_firebase.Flag_Enconding = False
	Else
		Log("** liblame Encode FAILED " & Main.gArq_Som_Ult)
	End If
End Sub

Sub StartWaveFile(Dir As String, FileName As String, SampleRate As Int, Mono As Boolean _
		, BitsPerSample As Int) As OutputStream
	File.Delete(Dir, FileName)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir, FileName, False, True)
	raf.WriteBytes("RIFF".GetBytes("ASCII"), 0, 4, raf.CurrentPosition)
	raf.CurrentPosition = 8 'skip 4 bytes for the size
	raf.WriteBytes("WAVE".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteBytes("fmt ".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(16, raf.CurrentPosition)
	raf.WriteShort(1, raf.CurrentPosition)
	Dim numberOfChannels As Int
	If Mono Then numberOfChannels = 1 Else numberOfChannels = 2
	raf.WriteShort(numberOfChannels, raf.CurrentPosition)
	raf.WriteInt(SampleRate, raf.CurrentPosition)
	raf.WriteInt(SampleRate * numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(BitsPerSample, raf.CurrentPosition)
	raf.WriteBytes("data".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(0, raf.CurrentPosition)
	raf.Close
	Return File.OpenOutput(Dir, FileName, True)
End Sub

Sub CloseWaveFile(Dir As String, FileName As String)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir, FileName, False, True)
	raf.WriteInt(raf.Size - 8, 4)
	raf.WriteInt(raf.Size - 44, 40)
	raf.Close
End Sub

